unit Demo_main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Button1: TButton;
    ComboBox1: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox2: TComboBox;
    Label6: TLabel;
    ComboBox3: TComboBox;
    GroupBox2: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    GroupBox3: TGroupBox;
    Button3: TButton;
    GroupBox4: TGroupBox;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Label1: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private-Deklarationen }
    F1, F2: Longword;
    function GetValue(ch: Integer; chL, chH: Byte): string;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  Interface_DLL_2;

procedure TForm1.Button1Click(Sender: TObject);
var
  w: Longword;
begin
  //MSR 1
  w:= StrToInt(Edit1.Text);
  F1:= OpenComport(@w);
  Edit9.Text:= IntToStr(F1);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  w: Longword;
begin
  //MSR 2
  w:= StrToInt(Edit2.Text);
  F2:= OpenComport(@w);
  Edit10.Text:= IntToStr(F2);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  res0, res1: Integer;
  in0, in1, in2, in3, in4, in5, in6: Word;
  out0, out1, out2, out3, out4, out5, out6: Word;
begin
  //--- Start measurements -----------------------------------------------------

  //MSR 1
  if F1 <> INVALID_HANDLE_VALUE then
  begin
    in0:= 6;
    in1:= 3;
    in2:= 0;
    in3:= $FF;
    in4:= $FF;
    in5:= 0;
    in6:= 0;
    res0:= TxRx(
      @F1,
      @in0, @in1, @in2, @in3, @in4, @in5, @in6,
      @out0, @out1, @out2, @out3, @out4, @out5, @out6
    );
  end;

  //MSR 2
  if F2 <> INVALID_HANDLE_VALUE then
  begin
    in0:= 6;
    in1:= 3;
    in2:= 0;
    in3:= $FF;
    in4:= $FF;
    in5:= 0;
    in6:= 0;
    res1:= TxRx(
      @F1,
      @in0, @in1, @in2, @in3, @in4, @in5, @in6,
      @out0, @out1, @out2, @out3, @out4, @out5, @out6
    );
  end;

  sleep(500);

  //--- Read results -----------------------------------------------------------

  //MSR 1
  if F1 <> INVALID_HANDLE_VALUE then
  begin
    in0:= 2;
    in1:= 2;
    in2:= ComboBox1.ItemIndex;
    in3:= ComboBox2.ItemIndex;
    in4:= ComboBox3.ItemIndex;
    in5:= 0;
    in6:= 0;
    if res0 = 0 then
      res0:= TxRx(
        @F1,
        @in0, @in1, @in2, @in3, @in4, @in5, @in6,
        @out0, @out1, @out2, @out3, @out4, @out5, @out6
      );
    if res0 = 0 then
    begin
      Edit3.Text:= GetValue(ComboBox1.ItemIndex, out1, out2);
      Edit4.Text:= GetValue(ComboBox2.ItemIndex, out3, out4);
      Edit5.Text:= GetValue(ComboBox3.ItemIndex, out5, out6);
    end
    else
    begin
      Edit3.Text:= '';
      Edit4.Text:= '';
      Edit5.Text:= '';
    end;
    Edit9.Text:= IntToStr(res0);
  end;

  //MSR 2
  if F1 <> INVALID_HANDLE_VALUE then
  begin
    in0:= 2;
    in1:= 2;
    in2:= ComboBox1.ItemIndex;
    in3:= ComboBox2.ItemIndex;
    in4:= ComboBox3.ItemIndex;
    in5:= 0;
    in6:= 0;
    if res1 = 0 then
      res1:= TxRx(
        @F1,
        @in0, @in1, @in2, @in3, @in4, @in5, @in6,
        @out0, @out1, @out2, @out3, @out4, @out5, @out6
      );
    if res1 = 0 then
    begin
      Edit6.Text:= GetValue(ComboBox4.ItemIndex, out1, out2);
      Edit7.Text:= GetValue(ComboBox5.ItemIndex, out3, out4);
      Edit8.Text:= GetValue(ComboBox6.ItemIndex, out5, out6);
    end
    else
    begin
      Edit6.Text:= '';
      Edit7.Text:= '';
      Edit8.Text:= '';
    end;
    Edit10.Text:= IntToStr(res1);
  end;
end;

function TForm1.GetValue(ch: Integer; chL, chH: Byte): string;
var
  y: SmallInt;
begin
  y:= SmallInt(256*chH+ chL);

  case ch of
    0: //p
      Result:= FormatFloat('0.0 mbar', 0.1*y);
    1: //T,(p)
      Result:= FormatFloat('0.0 C', 0.1*y);
    2, 3, 4: //ACC X
      begin
        if (y and $2000) = 0 then
          y:= y and $1FFF
        else
          y:= y or $E000;
        Result:= FormatFloat('0.000 g', 0.004*y);
      end;
    5: //RH
      Result:= FormatFloat('0.00 %', 0.01*y);
    6: //T,(RH)
      Result:= FormatFloat('0.00 C', 0.01*y);
    7: //T
      Result:= FormatFloat('0.00 C', 70/2047*y-10);
    8: //Marker
      Result:= FormatFloat('0', y);
    9, 10: //AIN1 + AIN2
      Result:= FormatFloat('0 cnts', y);
  else
    Result:= IntToStr(y);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  GroupBox1.Top:= 2;
  GroupBox1.Left:= 2;
  GroupBox2.Top:= GroupBox1.Top;
  GroupBox2.Left:= GroupBox1.Left+ GroupBox1.Width+2;

  GroupBox3.Top:= GroupBox1.Top+ GroupBox1.Height+ 2;
  GroupBox3.Left:= GroupBox1.Left;
  GroupBox4.Top:= GroupBox3.Top;
  GroupBox4.Left:= GroupBox3.Left+ GroupBox3.Width+2;

  ClientWidth:= GroupBox2.Left+ GroupBox2.Width+2;
  ClientHeight:= GroupBox3.Top+ GroupBox3.Height+2;

  ComboBox1.Clear;
  ComboBox1.Items.Add('p');
  ComboBox1.Items.Add('T,p');
  ComboBox1.Items.Add('ACC X');
  ComboBox1.Items.Add('ACC Y');
  ComboBox1.Items.Add('ACC Z');
  ComboBox1.Items.Add('RH');
  ComboBox1.Items.Add('T,RH');
  ComboBox1.Items.Add('T');
  ComboBox1.Items.Add('Marker');
  ComboBox1.Items.Add('AIN1');
  ComboBox1.Items.Add('AIN2');

  ComboBox2.Items.Assign(ComboBox1.Items);
  ComboBox3.Items.Assign(ComboBox1.Items);
  ComboBox4.Items.Assign(ComboBox1.Items);
  ComboBox5.Items.Assign(ComboBox1.Items);
  ComboBox6.Items.Assign(ComboBox1.Items);

  ComboBox1.ItemIndex:= 0;
  ComboBox2.ItemIndex:= 5;
  ComboBox3.ItemIndex:= 7;
  ComboBox4.ItemIndex:= 0;
  ComboBox5.ItemIndex:= 5;
  ComboBox6.ItemIndex:= 7;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if F1 <> INVALID_HANDLE_VALUE then
    CloseComport(@F1);
  if F2 <> INVALID_HANDLE_VALUE then
    CloseComport(@F2);
end;

end.
