// test_msr145Dlg.h : header file
//

#if !defined(AFX_TEST_MSR145DLG_H__1294CA8E_B625_448E_886A_96CF2C5A8CA9__INCLUDED_)
#define AFX_TEST_MSR145DLG_H__1294CA8E_B625_448E_886A_96CF2C5A8CA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


/////////////////////////////////////////////////////////////////////////////
// MSR145
typedef LRESULT APIENTRY GetDLLVersion(void); 
typedef LRESULT APIENTRY OpenComport(UCHAR PortIDX, LPSTR name);
typedef LRESULT APIENTRY CloseComport(UCHAR PortIDX);
typedef LRESULT APIENTRY WakeUp(UCHAR PortIDX);
typedef LRESULT APIENTRY TxRx(UCHAR PortIDX, UCHAR in0, UCHAR in1, UCHAR in2, 
	UCHAR in3, UCHAR in4, UCHAR in5, UCHAR in6, UCHAR* out0, UCHAR* out1, 
	UCHAR* out2, UCHAR* out3, UCHAR* out4, UCHAR* out5, UCHAR* out6);
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CTest_msr145Dlg dialog

class CTest_msr145Dlg : public CDialog
{
// Construction
public:
	CTest_msr145Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CTest_msr145Dlg)
	enum { IDD = IDD_TEST_MSR145_DIALOG };
	int		m_DLLVersion;
	int		m_OpenComport;
	CString	m_Port;
	int		m_GetValue;
	int		m_CloseComport;
	CString	m_Value;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTest_msr145Dlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

/////////////////////////////////////////////////////////////////////////////
// MSR145
	
	HINSTANCE		hinstLib;
	GetDLLVersion	*funcGetDLLVersion;
	OpenComport		*funcOpenComport;
	CloseComport	*funcCloseComport;
	WakeUp			*funcWakeUp;
	TxRx			*funcTxRx;
/////////////////////////////////////////////////////////////////////////////

	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CTest_msr145Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButton1();
	afx_msg void OnButton2();
	afx_msg void OnButton3();
	afx_msg void OnButton4();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TEST_MSR145DLG_H__1294CA8E_B625_448E_886A_96CF2C5A8CA9__INCLUDED_)
